Index: src/main/java/com/xpn/xwiki/plugin/lucene/SearchResults.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/lucene/SearchResults.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/lucene/SearchResults.java	(working copy)
@@ -19,6 +19,7 @@
  */
 package com.xpn.xwiki.plugin.lucene;
 
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.api.XWiki;
 import org.apache.log4j.Logger;
 import org.apache.lucene.search.Hits;
@@ -69,7 +70,7 @@
                         pageName = result.getWeb() + "." + result.getName();
                     }
                     if (result != null && result.isWikiContent() &&
-                        xwiki.checkAccess(pageName, "view") && xwiki.exists(pageName))
+                        xwiki.checkAccess(pageName, DocumentAction.VIEW) && xwiki.exists(pageName))
                     {
                         relevantResults.add(result);
                     }
@@ -172,7 +173,7 @@
                         pageName = result.getWeb() + "." + result.getName();
                     }
                     if (result != null && result.isWikiContent() && xwiki.exists(pageName) &&
-                            xwiki.checkAccess(pageName, "view"))
+                            xwiki.checkAccess(pageName, DocumentAction.VIEW))
                     {
                         if (resultcount>=listStartIndex) {
                             relResults.add(result);
Index: src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java	(working copy)
@@ -39,6 +39,7 @@
 
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.notify.XWikiActionNotificationInterface;
@@ -485,12 +486,12 @@
      * Notification of attachment uploads.
      *
      * @see com.xpn.xwiki.notify.XWikiActionNotificationInterface#notify(com.xpn.xwiki.notify.XWikiNotificationRule,
-     *com.xpn.xwiki.doc.XWikiDocument,java.lang.String,com.xpn.xwiki.XWikiContext)
+     *com.xpn.xwiki.doc.XWikiDocument,com.xpn.xwiki.api.DocumentAction,com.xpn.xwiki.XWikiContext)
      */
-    public void notify(XWikiNotificationRule arg0, XWikiDocument doc, String action,
+    public void notify(XWikiNotificationRule arg0, XWikiDocument doc, DocumentAction action,
                        XWikiContext context)
     {
-        if ("upload".equals(action)) {
+        if (DocumentAction.UPLOAD.equals(action)) {
             if (LOG.isDebugEnabled()) {
                 LOG.debug("upload action notification for doc " + doc.getName());
             }
Index: src/main/java/com/xpn/xwiki/atom/XWikiHelper.java
===================================================================
--- src/main/java/com/xpn/xwiki/atom/XWikiHelper.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/atom/XWikiHelper.java	(working copy)
@@ -24,6 +24,8 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.atom.lifeblog.UserBlog;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
@@ -97,11 +99,11 @@
     Iterator it = searchResults.iterator();
     while (it.hasNext()) {
       XWikiDocument doc = (XWikiDocument)it.next();
-      if (xwiki.getRightService().hasAccessLevel("edit", userName, doc.getFullName(), xwikiContext)) {
+      if (xwiki.getRightService().hasAccessLevel(AccessLevel.EDIT, userName, doc.getFullName(), xwikiContext)) {
         UserBlog userBlog = new UserBlog();
-        userBlog.setPostHref(doc.getExternalURL("lifeblog", "", xwikiContext));
-        userBlog.setFeedHref(doc.getExternalURL("view", "xpage=rdf", xwikiContext));
-        userBlog.setAlternateHref(doc.getExternalURL("view", "", xwikiContext));
+        userBlog.setPostHref(doc.getExternalURL(DocumentAction.valueOf("lifeblog"), "", xwikiContext));
+        userBlog.setFeedHref(doc.getExternalURL(DocumentAction.VIEW, "xpage=rdf", xwikiContext));
+        userBlog.setAlternateHref(doc.getExternalURL(DocumentAction.VIEW, "", xwikiContext));
         userBlogs.add(userBlog);
       }
     }
@@ -113,13 +115,33 @@
    * 
    * @param context
    * @return
-   * @throws XWikiException 
+   * @throws XWikiException
+   * @deprecated use {@link XWikiHelper#initXWikiContext(DocumentAction, HttpServletRequest, 
+   *             HttpServletResponse, ServletContext)} 
    */
   public void initXWikiContext(
       String action, 
       HttpServletRequest request, 
       HttpServletResponse response,
       ServletContext servletContext) throws XWikiException {
+    
+    this.initXWikiContext(DocumentAction.valueOf(action), request, 
+                          response, servletContext);  
+  }
+  
+  /**
+   * The version of {@link XWikiHelper#initXWikiContext(String, 
+   * HttpServletRequest, HttpServletResponse, ServletContext)} that uses {@link DocumentAction} as 
+   * a parameter.
+   * 
+   * @see XWikiHelper#initXWikiContext(String, HttpServletRequest, 
+   *      HttpServletResponse, ServletContext)
+   */
+  public void initXWikiContext(
+      DocumentAction action, 
+      HttpServletRequest request, 
+      HttpServletResponse response,
+      ServletContext servletContext) throws XWikiException {
     XWikiRequest xwikiRequest = new XWikiServletRequest(request);
     XWikiResponse xwikiResponse = new XWikiServletResponse(response);
     XWikiContext xwikiContext = Utils.prepareContext(
Index: src/main/java/com/xpn/xwiki/cache/impl/XWikiCacheListener.java
===================================================================
--- src/main/java/com/xpn/xwiki/cache/impl/XWikiCacheListener.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/cache/impl/XWikiCacheListener.java	(working copy)
@@ -29,6 +29,7 @@
 import com.opensymphony.oscache.base.events.*;
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
@@ -103,7 +104,7 @@
             // email notification, lucene plugin)
             //
             // This doesn't really work since the context may not have stuff like the request object
-            xwiki.getNotificationManager().verify(doc, "flush", context);
+            xwiki.getNotificationManager().verify(doc, DocumentAction.valueOf("flush"), context);
         }
         else
         {
Index: src/main/java/com/xpn/xwiki/xmlrpc/Comment.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/Comment.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/Comment.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.xmlrpc;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
 
@@ -51,7 +52,7 @@
         setContent(obj.getStringValue("content"));
         // setDate(obj.getDateValue("created"));
         setCreator(obj.getStringValue("creator"));
-        setUrl(doc.getURL("view", context));
+        setUrl(doc.getURL(DocumentAction.VIEW, context));
     }
 
     public String getId()
Index: src/main/java/com/xpn/xwiki/xmlrpc/BaseRpcHandler.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/BaseRpcHandler.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/BaseRpcHandler.java	(working copy)
@@ -24,6 +24,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.render.XWikiVelocityRenderer;
 import com.xpn.xwiki.web.*;
 
@@ -61,7 +62,8 @@
 
     protected XWikiContext getXWikiContext() throws XWikiException
     {
-        XWikiContext context = Utils.prepareContext("", request, response, econtext);
+        XWikiContext context = Utils.prepareContext(DocumentAction.NONE, 
+                                                    request, response, econtext);
         XWiki xwiki = XWiki.getXWiki(context);
         XWikiURLFactory urlf =
             xwiki.getURLFactoryService().createURLFactory(context.getMode(), context);
Index: src/main/java/com/xpn/xwiki/xmlrpc/User.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/User.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/User.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.xmlrpc;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 public class User
@@ -39,7 +40,7 @@
         this.name = userdoc.getName();
         this.fullname = userdoc.getStringValue("XWiki.XWikiUsers", "fullName");
         this.email = userdoc.getStringValue("XWiki.XWikiUsers", "email");
-        this.url = userdoc.getURL("view", context);
+        this.url = userdoc.getURL(DocumentAction.VIEW, context);
     }
 
     public String getName()
Index: src/main/java/com/xpn/xwiki/xmlrpc/ConfluenceRpcHandler.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/ConfluenceRpcHandler.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/ConfluenceRpcHandler.java	(working copy)
@@ -24,6 +24,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
@@ -179,8 +180,11 @@
         checkToken(token, context);
 
         XWikiDocument doc = new XWikiDocument(spaceKey, "WebHome");
-        return (new Space(spaceKey, spaceKey, doc.getURL("view", context), spaceKey, "WebHome"))
-            .getParameters();
+        return (new Space(spaceKey,
+            spaceKey,
+            doc.getURL(DocumentAction.VIEW, context),
+            spaceKey,
+            "WebHome")).getParameters();
     }
 
     /**
@@ -294,7 +298,7 @@
         try {
             context = getXWikiContext();
             XWiki xwiki = context.getWiki();
-            context.setAction("view");
+            context.setAction(DocumentAction.VIEW);
 
             // Verify authentication token
             checkToken(token, context);
@@ -321,7 +325,7 @@
         XWikiContext context = null;
         context = getXWikiContext();
         XWiki xwiki = context.getWiki();
-        context.setAction("view");
+        context.setAction(DocumentAction.VIEW);
 
         // Verify authentication token
         checkToken(token, context);
@@ -351,7 +355,7 @@
         XWikiContext context = null;
         context = getXWikiContext();
         XWiki xwiki = context.getWiki();
-        context.setAction("view");
+        context.setAction(DocumentAction.VIEW);
 
         // Verify authentication token
         checkToken(token, context);
@@ -386,7 +390,7 @@
             XWikiContext context = null;
             context = getXWikiContext();
             XWiki xwiki = context.getWiki();
-            context.setAction("save");
+            context.setAction(DocumentAction.SAVE);
 
             // Verify authentication token
             checkToken(token, context);
@@ -420,7 +424,7 @@
         XWikiContext context = null;
         context = getXWikiContext();
         XWiki xwiki = context.getWiki();
-        context.setAction("delete");
+        context.setAction(DocumentAction.DELETE);
 
         // Verify authentication token
         checkToken(token, context);
@@ -538,7 +542,7 @@
         Space space = new Space(new HashMap(spaceProperties));
 
         XWikiContext context = getXWikiContext();
-        context.setAction("save");
+        context.setAction(DocumentAction.SAVE);
 
         // Verify authentication token
         checkToken(token, context);
@@ -550,7 +554,7 @@
         context.getWiki().saveDocument(document, context);
 
         // Set space settings
-        space.setUrl(document.getURL("view", context));
+        space.setUrl(document.getURL(DocumentAction.VIEW, context));
         space.setHomepage(new Long(document.getId()).toString());
 
         return space.getParameters();
Index: src/main/java/com/xpn/xwiki/xmlrpc/Attachment.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/Attachment.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/Attachment.java	(working copy)
@@ -24,6 +24,7 @@
 import java.util.Map;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 
@@ -146,7 +147,7 @@
         setCreator(attachment.getAuthor());
         setCreated(attachment.getDate());
         setContentType(context.getWiki().getEngineContext().getMimeType(attachment.getFilename()));
-        setUrl(doc.getAttachmentURL(attachment.getFilename(), "download", context));
+        setUrl(doc.getAttachmentURL(attachment.getFilename(), DocumentAction.DOWNLOAD, context));
     }
 
     /**
Index: src/main/java/com/xpn/xwiki/xmlrpc/PageSummary.java
===================================================================
--- src/main/java/com/xpn/xwiki/xmlrpc/PageSummary.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/xmlrpc/PageSummary.java	(working copy)
@@ -20,6 +20,7 @@
 package com.xpn.xwiki.xmlrpc;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 import java.util.HashMap;
@@ -68,7 +69,7 @@
         this.setSpace(doc.getSpace());
         this.setParentId(doc.getParent());
         this.setTitle(doc.getFullName());
-        this.setUrl(doc.getURL("view", context));
+        this.setUrl(doc.getURL(DocumentAction.VIEW, context));
         this.setLocks(0);
     }
 
Index: src/main/java/com/xpn/xwiki/doc/XWikiDocument.java
===================================================================
--- src/main/java/com/xpn/xwiki/doc/XWikiDocument.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/doc/XWikiDocument.java	(working copy)
@@ -28,6 +28,7 @@
 import com.xpn.xwiki.content.parsers.ReplacementResultCollection;
 import com.xpn.xwiki.content.parsers.RenamePageReplaceLinkHandler;
 import com.xpn.xwiki.content.Link;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.api.DocumentSection;
 import com.xpn.xwiki.notify.XWikiNotificationRule;
 import com.xpn.xwiki.objects.BaseCollection;
@@ -661,21 +662,21 @@
 
     public String getAttachmentURL(String filename, XWikiContext context)
     {
-        return getAttachmentURL(filename, "download", context);
+        return getAttachmentURL(filename, DocumentAction.DOWNLOAD, context);
     }
 
-    public String getAttachmentURL(String filename, String action, XWikiContext context)
+    public String getAttachmentURL(String filename, DocumentAction action, XWikiContext context)
     {
         URL url = context.getURLFactory().createAttachmentURL(filename, getSpace(), getName(),
             action, null, getDatabase(), context);
         return context.getURLFactory().getURL(url, context);
     }
 
-    public String getExternalAttachmentURL(String filename, String action, XWikiContext context) {
+    public String getExternalAttachmentURL(String filename, DocumentAction action, XWikiContext context) {
         URL url = context.getURLFactory().createAttachmentURL(filename, getSpace(), getName(), action, null, getDatabase(), context);
         return url.toString();
     }
-    public String getAttachmentURL(String filename, String action, String querystring,
+    public String getAttachmentURL(String filename, DocumentAction action, String querystring,
         XWikiContext context)
     {
         URL url = context.getURLFactory().createAttachmentURL(filename, getSpace(), getName(),
@@ -698,7 +699,7 @@
         return context.getURLFactory().getURL(url, context);
     }
 
-    public String getURL(String action, boolean redirect, XWikiContext context)
+    public String getURL(DocumentAction action, boolean redirect, XWikiContext context)
     {
         URL url = context.getURLFactory()
             .createURL(getSpace(), getName(), action, null, null, getDatabase(), context);
@@ -713,38 +714,58 @@
         }
     }
 
-    public String getURL(String action, XWikiContext context)
+    public String getURL(DocumentAction action, XWikiContext context)
     {
         return getURL(action, false, context);
     }
 
-    public String getURL(String action, String querystring, XWikiContext context)
+    public String getURL(DocumentAction action, String querystring, XWikiContext context)
     {
         URL url = context.getURLFactory().createURL(getSpace(), getName(), action,
             querystring, null, getDatabase(), context);
         return context.getURLFactory().getURL(url, context);
     }
 
-    public String getExternalURL(String action, XWikiContext context)
+    public String getExternalURL(DocumentAction action, XWikiContext context)
     {
         URL url = context.getURLFactory().createExternalURL(getSpace(), getName(), action,
             null, null, getDatabase(), context);
         return url.toString();
     }
+    
+    /**
+     * @see XWikiDocument#getExternalURL(DocumentAction, XWikiContext)
+     * @deprecated use {@link XWikiDocument#getExternalURL(DocumentAction, XWikiContext)} 
+     */
+    public String getExternalURL(String action, XWikiContext context)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getExternalURL(documentAction, context);
+    }
 
-    public String getExternalURL(String action, String querystring, XWikiContext context)
+    public String getExternalURL(DocumentAction action, String querystring, XWikiContext context)
     {
         URL url = context.getURLFactory().createExternalURL(getSpace(), getName(), action,
             querystring, null, getDatabase(), context);
         return url.toString();
     }
+    
+    /**
+     * @see XWikiDocument#getExternalURL(DocumentAction, String, XWikiContext)
+     * @deprecated {@link XWikiDocument#getExternalURL(DocumentAction, XWikiContext)} 
+     */
+    public String getExternalURL(String action, String querystring, XWikiContext context)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getExternalURL(documentAction, querystring, context);
+    }    
 
     public String getParentURL(XWikiContext context) throws XWikiException
     {
         XWikiDocument doc = new XWikiDocument();
         doc.setFullName(getParent(), context);
         URL url = context.getURLFactory()
-            .createURL(doc.getSpace(), doc.getName(), "view", null, null, getDatabase(), context);
+            .createURL(doc.getSpace(), doc.getName(), DocumentAction.VIEW, null, null, getDatabase(), context);
         return context.getURLFactory().getURL(url, context);
     }
 
@@ -3454,14 +3475,14 @@
     {
         com.xpn.xwiki.XWiki xwiki = context.getWiki();
         if (getContent().indexOf("includeForm(") != -1) {
-            return getEditURL("inline", "", context);
+            return getEditURL(DocumentAction.INLINE, "", context);
         } else {
             String editor = xwiki.getEditorPreference(context);
-            return getEditURL("edit", editor, context);
+            return getEditURL(DocumentAction.EDIT, editor, context);
         }
     }
 
-    public String getEditURL(String action, String mode, XWikiContext context) throws XWikiException
+    public String getEditURL(DocumentAction action, String mode, XWikiContext context) throws XWikiException
     {
         com.xpn.xwiki.XWiki xwiki = context.getWiki();
         String language = "";
@@ -3473,7 +3494,7 @@
         return getEditURL(action, mode, language, context);
     }
 
-    public String getEditURL(String action, String mode, String language, XWikiContext context)
+    public String getEditURL(DocumentAction action, String mode, String language, XWikiContext context)
     {
         StringBuffer editparams = new StringBuffer();
         if (!mode.equals("")) {
Index: src/main/java/com/xpn/xwiki/notify/XWikiPageNotification.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/XWikiPageNotification.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/XWikiPageNotification.java	(working copy)
@@ -3,6 +3,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import org.apache.commons.lang.StringUtils;
 import org.apache.commons.logging.Log;
@@ -11,7 +12,7 @@
 public class XWikiPageNotification implements XWikiActionNotificationInterface {
     private static final Log log = LogFactory.getLog(XWikiPageNotification.class);
 
-    public void notify(XWikiNotificationRule rule, XWikiDocument doc, String action, XWikiContext context) {
+    public void notify(XWikiNotificationRule rule, XWikiDocument doc, DocumentAction action, XWikiContext context) {
         try {
             String notifpages = context.getWiki().getXWikiPreference("notification_pages", context);
             if ((notifpages!=null)&&(!notifpages.equals(""))) {
@@ -31,7 +32,7 @@
         }
     }
 
-    protected void notifyPage(String page, XWikiNotificationRule rule, XWikiDocument doc, String action, XWikiContext context) {
+    protected void notifyPage(String page, XWikiNotificationRule rule, XWikiDocument doc, DocumentAction action, XWikiContext context) {
         XWikiActionNotificationInterface notif = null;
         try {
             XWiki xwiki = context.getWiki();
Index: src/main/java/com/xpn/xwiki/notify/XWikiActionRule.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/XWikiActionRule.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/XWikiActionRule.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.notify;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 public class XWikiActionRule implements XWikiNotificationRule {
@@ -53,7 +54,7 @@
     public void verify(XWikiDocument newdoc, XWikiDocument olddoc, XWikiContext context) {
     }
 
-    public void verify(XWikiDocument doc, String action, XWikiContext context) {
+    public void verify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
     	if(!isPostverify()) return;
         try {
             getTarget().notify(this, doc, action, context);
@@ -64,7 +65,7 @@
         }
     }
 
-    public void preverify(XWikiDocument doc, String action, XWikiContext context) {
+    public void preverify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
     	if(!isPreverify()) return;
         try {
             getTarget().notify(this, doc, action, context);
Index: src/main/java/com/xpn/xwiki/notify/XWikiActionNotificationInterface.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/XWikiActionNotificationInterface.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/XWikiActionNotificationInterface.java	(working copy)
@@ -22,8 +22,9 @@
 package com.xpn.xwiki.notify;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 public interface XWikiActionNotificationInterface {
-    public void notify(XWikiNotificationRule rule, XWikiDocument doc, String action, XWikiContext context);
+    public void notify(XWikiNotificationRule rule, XWikiDocument doc, DocumentAction action, XWikiContext context);
 }
Index: src/main/java/com/xpn/xwiki/notify/DocChangeRule.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/DocChangeRule.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/DocChangeRule.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.notify;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 public class DocChangeRule implements XWikiNotificationRule {
@@ -46,9 +47,9 @@
         getTarget().notify(this, newdoc, olddoc, XWikiDocChangeNotificationInterface.EVENT_CHANGE, context);
     }
 
-    public void verify(XWikiDocument doc, String action, XWikiContext context) {
+    public void verify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
     }
 
-    public void preverify(XWikiDocument doc, String action, XWikiContext context) {
+    public void preverify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
     }
 }
Index: src/main/java/com/xpn/xwiki/notify/XWikiNotificationRule.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/XWikiNotificationRule.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/XWikiNotificationRule.java	(working copy)
@@ -22,10 +22,11 @@
 package com.xpn.xwiki.notify;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 public interface XWikiNotificationRule {
     public void verify(XWikiDocument newdoc, XWikiDocument olddoc, XWikiContext context);
-    public void verify(XWikiDocument doc, String action, XWikiContext context);
-    public void preverify(XWikiDocument doc, String action, XWikiContext context);
+    public void verify(XWikiDocument doc, DocumentAction action, XWikiContext context);
+    public void preverify(XWikiDocument doc, DocumentAction action, XWikiContext context);
 }
Index: src/main/java/com/xpn/xwiki/notify/XWikiNotificationManager.java
===================================================================
--- src/main/java/com/xpn/xwiki/notify/XWikiNotificationManager.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/notify/XWikiNotificationManager.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.notify;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 import java.util.HashMap;
@@ -112,7 +113,7 @@
             ((XWikiNotificationRule)grules.get(i)).verify(newdoc, olddoc, context);
     }
 
-    public void verify(XWikiDocument doc, String action, XWikiContext context) {
+    public void verify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
         // Call rules explicitely for any actions of this document
         Vector vnamedrules;
         String name = doc.getFullName();
@@ -143,7 +144,7 @@
             ((XWikiNotificationRule)grules.get(i)).verify(doc, action, context);
     }
 
-    public void preverify(XWikiDocument doc, String action, XWikiContext context) {
+    public void preverify(XWikiDocument doc, DocumentAction action, XWikiContext context) {
         // Call rules explicitely for any actions of this document
         Vector vnamedrules;
         String name = doc.getFullName();
Index: src/main/java/com/xpn/xwiki/api/Api.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/Api.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/api/Api.java	(working copy)
@@ -86,13 +86,25 @@
     }
 
     /**
+     * @see Api#hasAccessLevel(AccessLevel, String)
+     * @deprecated use {@link Api#hasAccessLevel(AccessLevel, String)} 
+     * 
+     */
+    public boolean hasAccessLevel(String right, String docname) throws XWikiException
+    {
+        AccessLevel accessLevel = AccessLevel.valueOf(right);
+        return this.hasAccessLevel(accessLevel, docname);
+    }
+    
+    
+    /**
      * @param right the name of the right to verify (eg "programming", "admin", "register", etc)
      * @param docname the document for which to verify the right
      * @return true if the current user has the specified right
      * @exception XWikiException in case of an error finding the document or accessing groups
      *            information
-     */
-    public boolean hasAccessLevel(String right, String docname) throws XWikiException
+     */    
+    public boolean hasAccessLevel(AccessLevel right, String docname) throws XWikiException
     {
         com.xpn.xwiki.XWiki xwiki = context.getWiki();
         return xwiki.getRightService().hasAccessLevel(right, context.getUser(), docname, context);
